function dxMfdt=xUL_f2d_dxdt_rv(t,xMf)
%
% Written by Kayo Ide (University of Maryland)
% 2015 August

%% global
global dxdt_prm
global ixMf_strt ixMf_end
global ido_xMf
global ido

%% setup
dxMfdt=zeros(numel(xMf),1);

%% particles
if(ido_xMf-ido==0);
    nd=1; ix1=[ixMf_strt.x(nd):ixMf_end.x(nd)];
    nd=2; ix2=[ixMf_strt.x(nd):ixMf_end.x(nd)];
    dxdt=zeros(size([ix1 ix2]'));
    for nv=1:dxdt_prm.Nv
        nvx=dxdt_prm.ixMf_v+nv;
        nd=1; dx1=xMf(ix1)-xMf(nvx(nd));
        nd=2; dx2=xMf(ix2)-xMf(nvx(nd));
        rv2=(dx1).^2+(dx2).^2;
        rv2(rv2<dxdt_prm.Rv2(nv))=dxdt_prm.Rv2(nv);
        dxdt=dxdt+[-dx2; dx1].*repmat((dxdt_prm.Gv(nv))./rv2,2,1);
    end
    dxMfdt([ix1 ix2])=dxdt;
    % M ode
    dxMfdt([ixMf_strt.M:ixMf_end.M])=sqrt(dxMfdt(ix1).^2 + dxMfdt(ix2).^2);
end

%% vortices
if(dxdt_prm.Nv>1);
   for nv=1:dxdt_prm.Nv-1; 
       nxv=dxdt_prm.ixMf_v+nv;
       for kv=nv+1:dxdt_prm.Nv;
           kxv=dxdt_prm.ixMf_v+kv;
           dxv=xMf(kxv)-xMf(nxv);
           rv2=dxv'*dxv;
           dxMfdt(kxv)=dxMfdt(kxv)...
               +[-dxv(2); dxv(1)]*(dxdt_prm.Gv(nv)/max([rv2 dxdt_prm.Rv2(nv)],[],2));  
           dxMfdt(nxv)=dxMfdt(nxv)...
               +[ dxv(2);-dxv(1)]*(dxdt_prm.Gv(kv)/max([rv2 dxdt_prm.Rv2(kv)],[],2));        
       end
   end
end

dxMfdt=dxMfdt(:);

return